package com.app.brush.guitar.ink.gallery;


import android.content.Context;
import android.content.Intent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.FrameLayout;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.cardview.widget.CardView;
import androidx.recyclerview.widget.RecyclerView;

import com.bumptech.glide.Glide;
import com.app.brush.guitar.ink.R;
import com.app.brush.guitar.ink.drama.DichotomyDetails;
import com.app.brush.guitar.ink.iguana.UbiquitousSerene;
import com.app.brush.guitar.ink.canvas.JubilantDeleteFavorite;
import com.app.brush.guitar.ink.eraser.SetKeyboardAmplify;

import java.util.ArrayList;
import java.util.List;

public class FavoriteElucidate extends RecyclerView.Adapter<FavoriteElucidate.ForYouViewHolder> {

    private Context mContext;
    private List<DichotomyDetails> mList = new ArrayList<>();

    private JubilantDeleteFavorite mCallBack;

    public FavoriteElucidate(Context context) {
        mContext = context;
    }

    public void setForYouList(List<DichotomyDetails> list) {
        this.mList = list;
        notifyDataSetChanged();
    }


    public void setRemoveLike(JubilantDeleteFavorite callback) {
        mCallBack = callback;
    }

    @NonNull
    @Override
    public ForYouViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {

        View view = LayoutInflater.from(mContext).inflate(R.layout.quick_adapter_favorite_item, parent, false);
        return new ForYouViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull ForYouViewHolder holder, int position) {
        DichotomyDetails beanDetails = mList.get(position);
        String thumbGif = beanDetails.getThumbGif();
        String thumb = beanDetails.getThumbUrl();
        if (!thumbGif.isEmpty()) {
            UbiquitousSerene.INSTANCE.loadWepJif(mContext, thumbGif, holder.itemImg);
        } else {
            Glide.with(mContext)
                    .load(thumb).error(R.drawable.place_holder)
                    .placeholder(R.drawable.place_holder).into(holder.itemImg);
        }
        holder.itemFavorite.setSelected(true);
        holder.layoutFavorite.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                holder.itemFavorite.setSelected(false);
                int adapterPosition = holder.getAdapterPosition();
                notifyItemRemoved(adapterPosition);
                if (mCallBack != null) {
                    mCallBack.OnRemoveLike(beanDetails);
                }
            }
        });
        holder.cardView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intentApply = new Intent(mContext, SetKeyboardAmplify.class);
                intentApply.putExtra(SetKeyboardAmplify.SOURCE_KEY, beanDetails);
                intentApply.putExtra(SetKeyboardAmplify.DISPLAY_URL_KEY, beanDetails.getImgPath());
                intentApply.putExtra(SetKeyboardAmplify.ZIP_URL_KEY, beanDetails.getZipPath());
                intentApply.putExtra(SetKeyboardAmplify.NAME_KEY, beanDetails.getTitleName());
                intentApply.putExtra(SetKeyboardAmplify.GIF_KEY, beanDetails.getImgGif());
                String intent_thumb;
                if (!thumbGif.isEmpty()) {
                    intent_thumb = thumbGif;
                } else {
                    intent_thumb = thumb;
                }
                intentApply.putExtra(SetKeyboardAmplify.THUMB_KEY, intent_thumb);
                mContext.startActivity(intentApply);


            }
        });


    }

    @Override
    public int getItemCount() {
        return mList.size();
    }

    public static class ForYouViewHolder extends RecyclerView.ViewHolder {

        private CardView cardView;
        private FrameLayout layoutFavorite;
        private ImageView itemImg, itemFavorite;

        public ForYouViewHolder(@NonNull View itemView) {
            super(itemView);
            cardView = itemView.findViewById(R.id.card_view);
            layoutFavorite = itemView.findViewById(R.id.layout_favorite);
            itemImg = itemView.findViewById(R.id.im);
            itemFavorite = itemView.findViewById(R.id.im_favorite);

        }

    }

}
